Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Service_Manager Class Reference

Provide a standard ACE service for managing all the services configured in an <ACE_Service_Repository>. More...

`#include <Service_Manager.h>`

Inheritance diagram for ACE_Service_Manager:

[legend]
Collaboration diagram for ACE_Service_Manager:

[legend]
List of all members.

## Public Methods
| ACE_Service_Manager (void)
| Constructor. More...
| ~ACE_Service_Manager (void)
| Destructor. More...
## Protected Methods
virtual int | reconfigure_services (void)
| Trigger a reconfiguration of the Service Configurator by. More...
virtual int | list_services (void)
| Determine all the services offered by this daemon and return the information back to the client. More...
virtual int | init (int argc, ACE_TCHAR *argv[])
| Initializes object when dynamic linking occurs. More...
virtual int | info (ACE_TCHAR **info_string, size_t length) const
| Returns information on a service object. More...
virtual int | fini (void)
| Terminates object when dynamic unlinking occurs. More...
virtual int | suspend (void)
| Temporarily disable a service without removing it completely. More...
virtual int | resume (void)
| Re-enable a previously suspended service. More...
void | dump (void) const
| Dump the state of an object. More...
## Protected Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks. More...
## Private Methods
int | open (const ACE_INET_Addr &sia)
virtual ACE_HANDLE | get_handle (void) const
| Get the I/O handle. More...
virtual int | handle_input (ACE_HANDLE fd)
| Called when input events occur (e.g., connection or data). More...
virtual int | handle_close (ACE_HANDLE fd, ACE_Reactor_Mask)
| Called when a <handle_*()> method returns -1 or when the <remove_handler> method is called on an <ACE_Reactor>. The <close_mask> indicates which event has triggered the <handle_close> method callback on a particular <handle>. More...
virtual int | handle_signal (int signum, siginfo_t *, ucontext_t *)
| Called when object is signaled by OS (either via UNIX signals or when a Win32 object becomes signaled). More...
virtual void | process_request (ACE_TCHAR *request)
| Handle one request. More...
## Private Attributes
ACE_SOCK_Stream | client_stream_
| Connection to the client (we only support one client connection at a time). More...
ACE_SOCK_Acceptor | acceptor_
| Acceptor instance. More...
int | debug_
| Keep track of the debugging level. More...
int | signum_
| The signal used to trigger reconfiguration. More...
## Static Private Attributes
u_short | DEFAULT_PORT_ = 10000
| Default port for the Acceptor to listen on. More...

## Detailed Description

Provide a standard ACE service for managing all the services configured in an <ACE_Service_Repository>.

This implementation is simple and just handles each client request one at a time. There are currently 3 types of requests: + List services: If the string "help" is sent, return a list of all the services supported by the Service Configurator. + Reconfigure: If the string "reconfigure" is sent trigger a reconfiguration, which will re-read the local <svc.conf> file. + Process directive: If neither "help" nor "reconfigure" is sent, simply treat the incoming string as a process directive and pass it along to <ACE_Service_Config::process_directive>. This allows remote configuration via command-line instructions like % echo suspend My_Remote_Service | telnet hostname 3911

Each request is associated with a new connection, which is closed when the request is processed. In addition, you must be using the singleton <ACE_Reactor::instance> in order to trigger reconfigurations.

## Constructor & Destructor Documentation

ACE_Service_Manager::ACE_Service_Manager | ( | void |  | ) |

| Constructor.

ACE_INLINE ACE_Service_Manager::~ACE_Service_Manager | ( | void |  | ) |

| Destructor.

## Member Function Documentation

void ACE_Service_Manager::dump | ( | void |  | ) | const`[protected]`

| Dump the state of an object.

int ACE_Service_Manager::fini | ( | void |  | ) | `[protected, virtual]`

| Terminates object when dynamic unlinking occurs. Reimplemented from ACE_Shared_Object.

ACE_HANDLE ACE_Service_Manager::get_handle | ( | void |  | ) | const`[private, virtual]`

| Get the I/O handle. Reimplemented from ACE_Event_Handler.

int ACE_Service_Manager::handle_close | ( | ACE_HANDLE | fd,
|  | ACE_Reactor_Mask | close_mask
| ) | `[private, virtual]`

| Called when a <handle_*()> method returns -1 or when the <remove_handler> method is called on an <ACE_Reactor>. The <close_mask> indicates which event has triggered the <handle_close> method callback on a particular <handle>. Reimplemented from ACE_Event_Handler.

int ACE_Service_Manager::handle_input | ( | ACE_HANDLE | fd | ) | `[private, virtual]`

| Called when input events occur (e.g., connection or data). Reimplemented from ACE_Event_Handler.

int ACE_Service_Manager::handle_signal | ( | int | signum,
|  | siginfo_t * | si,
|  | ucontext_t * | u
| ) | `[private, virtual]`

| Called when object is signaled by OS (either via UNIX signals or when a Win32 object becomes signaled). Reimplemented from ACE_Event_Handler.

int ACE_Service_Manager::info | ( | ACE_TCHAR ** | strp,
|  | size_t | length
| ) | const`[protected, virtual]`

| Returns information on a service object. Reimplemented from ACE_Shared_Object.

int ACE_Service_Manager::init | ( | int | argc,
|  | ACE_TCHAR * | argv[]
| ) | `[protected, virtual]`

| Initializes object when dynamic linking occurs. Reimplemented from ACE_Shared_Object.

int ACE_Service_Manager::list_services | ( | void |  | ) | `[protected, virtual]`

| Determine all the services offered by this daemon and return the information back to the client.

int ACE_Service_Manager::open | ( | const ACE_INET_Addr & | sia | ) | `[private]`

void ACE_Service_Manager::process_request | ( | ACE_TCHAR * | request | ) | `[private, virtual]`

| Handle one request.

int ACE_Service_Manager::reconfigure_services | ( | void |  | ) | `[protected, virtual]`

| Trigger a reconfiguration of the Service Configurator by.

int ACE_Service_Manager::resume | ( | void |  | ) | `[protected, virtual]`

| Re-enable a previously suspended service. Reimplemented from ACE_Service_Object.

int ACE_Service_Manager::suspend | ( | void |  | ) | `[protected, virtual]`

| Temporarily disable a service without removing it completely. Reimplemented from ACE_Service_Object.

## Member Data Documentation

ACE_SOCK_Acceptor ACE_Service_Manager::acceptor_`[private]`

| Acceptor instance.

ACE_Service_Manager::ACE_ALLOC_HOOK_DECLARE`[protected]`

| Declare the dynamic allocation hooks.

ACE_SOCK_Stream ACE_Service_Manager::client_stream_`[private]`

| Connection to the client (we only support one client connection at a time).

int ACE_Service_Manager::debug_`[private]`

| Keep track of the debugging level.

u_short ACE_Service_Manager::DEFAULT_PORT_ = 10000`[static, private]`

| Default port for the Acceptor to listen on.

int ACE_Service_Manager::signum_`[private]`

| The signal used to trigger reconfiguration.

The documentation for this class was generated from the following files:

- Service_Manager.h
- Service_Manager.cpp
- Service_Manager.i